# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# perl_vendorlib/perl_vendorarch not defined by default prior to F-2
%{!?perl_vendorarch: %global perl_vendorarch %(eval "`perl -V:installvendorarch`"; echo $installvendorarch)}

Summary:	Source Filters for Perl
Name:		perl-Filter
Version:	1.43
Release:	1.%{__distinit}%{__distvers}
License:	GPL+ or Artistic
Group:		Development/Libraries
Url:		http://search.cpan.org/dist/Filter/
Source0:	http://search.cpan.org/CPAN/authors/id/R/RU/RURBAN/Filter-%{version}.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildRequires:	perl(Carp)
BuildRequires:	perl(Config)
BuildRequires:	perl(DynaLoader)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(strict)
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Test::Pod)
BuildRequires:	perl(vars)
BuildRequires:	perl(warnings)
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

# Don't "provide" private Perl libs
%{?perl_default_filter}

%description
This package provides source-level filters for Perl modules. Source
filters alter the program text of a module before Perl sees it, much
as a C preprocessor alters the source text of a C program before the
compiler sees it.

%prep
%setup -q -n Filter-%{version}

# Don't attempt to build for distributions where Filter
# is integrated into the main perl package
if [ -f %{perl_archlib}/Filter/Util/Call.pm ]; then
	echo "This distribution already has Filter::Util::Call in the main perl package; aborting build" 1>&2
	exit 1
fi

# Fix script interpreter
sed -i -e 's|^#!/usr/local/bin/perl|#!/usr/bin/perl|' examples/filtdef

# Avoid doc-file dependencies
chmod -x examples/filt{def,uu}
%global reqfilt /bin/sh -c "%{__perl_requires} | grep -Evx 'perl[(](Compress::Zlib|IO::File)[)]'"
%define __perl_requires %{reqfilt}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

# Build process creates junk
find . -type f -name '*.bak' -exec rm -vf {} ';'

%check
make test

%clean
rm -rf %{buildroot}

%install
rm -rf %{buildroot}
make pure_install PERL_INSTALL_ROOT=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
find %{buildroot} -type f -name '*.bs' -a -size 0 -exec rm -f {} ';'
find %{buildroot} -depth -type d -exec rmdir {} ';' 2>/dev/null
chmod -R u+w %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes README examples/
%{perl_vendorarch}/filter-util.pl
%doc %{perl_vendorarch}/perlfilter.pod
%{perl_vendorarch}/Filter/
%{perl_vendorarch}/auto/Filter/
%{_mandir}/man3/Filter::cpp.3pm*
%{_mandir}/man3/Filter::decrypt.3pm*
%{_mandir}/man3/Filter::exec.3pm*
%{_mandir}/man3/Filter::sh.3pm*
%{_mandir}/man3/Filter::tee.3pm*
%{_mandir}/man3/Filter::Util::Call.3pm*
%{_mandir}/man3/Filter::Util::Exec.3pm*
%{_mandir}/man3/perlfilter.3pm*

%changelog
* Wed Feb 22 2012 Paul Howarth <paul@city-fan.org> 1.43-1
- Update to 1.43:
  - Fix more windows tests:
    http://www.cpantesters.org/cpan/report/9e790a72-6bf5-1014-9f3b-641f296be760

* Tue Feb 21 2012 Paul Howarth <paul@city-fan.org> 1.42-1
- Update to 1.42:
  - Improve t/tee.t test 5 on Windows, which allows read access for all
    Administrator group members

* Sat Feb 18 2012 Paul Howarth <paul@city-fan.org> 1.41-1
- Update to 1.41:
  - Fix tee and all tests to work with Perl 5.14 and higher
  - PVIO has no IV field anymore, so abuse the empty IoOFP, which is only used
    for printing, not reading (fixes CPAN RT#56875 and more)
  - Tested for 5.6.2, 5.8.4, 5.8.5, 5.8.8, 5.8.9, 5.10.1, 5.12.4, 5.14.2,
    5.15.7
  - Hide example packages from the pause indexer
- This release by RURBAN -> update source URL
- Add buildreqs for Perl core modules that might be dual-lived

* Tue Oct 18 2011 Paul Howarth <paul@city-fan.org> 1.39-2
- Fix dist tag for CentOS 6 and Scientific Linux

* Sun May  1 2011 Paul Howarth <paul@city-fan.org> 1.39-1
- Update to 1.39:
  - Fix decrypt to work with Perl 5.14 (CPAN RT#67656)

* Tue Apr 26 2011 Paul Howarth <paul@city-fan.org> 1.38-1
- Update to 1.38:
  - Bumped all versions to match the distribution version number, as having
    module versions different from distribution version results in dependency
    confusion (CPAN RT#67655)
  - Fix decrypt to work with Perl 5.14 (CPAN RT#67656)
  - Update the Filter-Simple URL (CPAN RT#49778)
- Fix doc-file dependencies
- Nobody else likes macros for commands

* Wed Sep 16 2009 Paul Howarth <paul@city-fan.org> 1.37-1
- Initial RPM package
